﻿* Aloha DivBlock Plugin
* -----------------
* This plugin provides an interface to allow the user to create a div block section in the editor with just a single click of a button
*/


// define the Source Viewer module using RequireJS
define([
    'aloha',
    'jquery',
    'aloha/plugin',
    'ui/ui',
	'ui/button',
	'ui/toolbar',
	'ui/ui-plugin',
	'aloha/console',
    'css!./css/divBlock-plugin'],
// callback executed once dependencies are loaded by RequireJS
    function (Aloha,
            jQuery,
			Plugin,
			Ui,
			Button,
            Dialog,
			i18n,
			i18nCore,
            console) {
        // members
		// replace divBlock with your custom name if customizing
        var namespace = "ektron-aloha-divBlock-";

        // create and register the Plugin
		// replace divBlock with your custom name if customizing
        return Plugin.create("divBlock", {
            defaults: {},

            init: function () {
                var that = this;
                that.createButton();
            },

            /* Helpers
            ----------------------------------*/

            insertDiv: function(){
                var range = Aloha.Selection.getRangeObject(),
                    newDiv,
                    selectedEdit = jQuery('.aloha-editable-active');

                if (range.isCollapsed()) {
                    newDiv = jQuery('<div>My Div Block</div>');
                    GENTICS.Utils.Dom.insertIntoDOM(newDiv, range, selectedEdit);
                    range.startContainer = range.endContainer = newDiv.contents().get(0);
                    range.startOffset = 0;
                    range.endOffset = newDiv.innerText.length;
                }
                else {
                    newDiv = jQuery('<div>My Div Block</div>');
                    GENTICS.Utils.Dom.addMarkup(range, newDiv, false);
                    range.select();
                }
            },

            createButton: function () {
                // provide locally scoped version of this for use in callbacks, etc. 
                // and define the tab we will insert the button into
                var that = this;

                // define the divBlock button
				// replace divBlock, tooltip and click function with your custom name/value/function if customizing
                this.divBlockButton = Ui.adopt('divBlock', Button, {
                    tooltip: "Insert DIV",
                    icon: 'ektron-aloha-button ' + this.nsString("button"),
                    scope: 'Aloha.continuoustext',
                    click: function () {
                        that.insertDiv();
                    }
                });
            },

            // namespacing method for various strings used within the plugin
            nsString: function (string) {
                return namespace + string;
            }
        });
    }
);